import { faker } from '@faker-js/faker/locale/zh_CN'
import { pinyin } from 'pinyin-pro'

export function getData() {
    const data = Array(1000)
        .fill(0)
        .map((item) => {
            return {
                id: item,
                name: faker.name.lastName() + faker.name.firstName(),
                phone: faker.phone.number('1###########'),
                avatar: faker.image.avatar(),
                unit: faker.company.name(),
                checked: false,
            }
        })

    const result = data
        .map((item: any) => {
            const props = {}
            if (item.name) {
                item.letter = pinyin(item.name.charAt(), { toneType: 'none', pattern: 'first' })[0].toUpperCase()
            } else {
                item.letter = '#'
            }

            return {
                ...item,
                ...props,
                // TODO: 存在性能问题，需要优化后再使用
                // src: item.avatar || '/static/images/me/user_default.jpg',
                text: item.name,
                subText: item.unit,
            }
        })
        .reduce((prev: any, cur: any) => {
            const letter = cur.letter
            const index = prev.findIndex((item: any) => item.letter === letter)
            if (index === -1) {
                prev.push({
                    letter,
                    items: [cur],
                })
            } else {
                prev[index].items.push(cur)
            }
            return prev
        }, [])
        .sort((a: any, b: any) => {
            return a.letter.charCodeAt(0) - b.letter.charCodeAt(0)
        })

    return result
}
